net.sf.jasperreports.engine.fill

## Class JRFillElement

- java.lang.Object
- - net.sf.jasperreports.engine.fill.JRFillElement

- All Implemented Interfaces:
    java.lang.Cloneable, DynamicPropertiesHolder, JRFillCloneable, JRChild, JRCloneable, JRCommonElement, JRElement, JRIdentifiable, JRPropertiesHolder, JRStyleContainer, JRStyleSetter, JRVisitable
  Direct Known Subclasses:
    JRFillBreak, JRFillChart, JRFillComponentElement, JRFillCrosstab, JRFillFrame, JRFillGenericElement, JRFillGraphicElement, JRFillSubreport, JRFillTextElement

      public abstract class JRFillElement
      extends java.lang.Object
      implements JRElement, JRFillCloneable, JRStyleSetter, DynamicPropertiesHolder

  Version:
    $Id: JRFillElement.java 6770 2013-11-22 14:48:55Z lucianc $
  Author:
    Teodor Danciu (teodord@users.sourceforge.net)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected JRFillBand` | `band`
    `protected JRFillElementContainer` | `conditionalStylesContainer`
    `protected byte` | `currentEvaluation`
    `protected JRStyle` | `currentStyle`
    `protected JRDefaultStyleProvider` | `defaultStyleProvider`
    `protected java.util.Map<JREvaluationTime,net.sf.jasperreports.engine.fill.JRFillElement.DelayedEvaluations>` | `delayedEvaluationsMap`
    `protected JRPropertiesMap` | `dynamicProperties`
    `protected java.util.List<java.lang.String>` | `dynamicTransferProperties`
    `protected JRFillElementGroup` | `elementGroup`
    `protected JRFillExpressionEvaluator` | `expressionEvaluator`
    `protected FillContainerContext` | `fillContainerContext`
    `protected JRBaseFiller` | `filler`
    `protected JRStyle` | `initStyle`
    `protected JRPropertiesMap` | `mergedProperties`
    `protected JROriginProvider` | `originProvider`
    `protected JRElement` | `parent`
    `protected PrintElementOriginator` | `printElementOriginator`
    `protected JRGroup` | `printWhenGroupChanges`
    `protected java.util.List<JRPropertyExpression>` | `propertyExpressions`
    `protected JRStyle` | `providerStyle`
    `protected JRPropertiesMap` | `staticProperties`
    `protected java.util.List<StyleProvider>` | `styleProviders`
    `protected java.util.Map<JRStyle,JRTemplateElement>` | `templates`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `JRFillElement(JRBaseFiller filler, JRElement element, JRFillObjectFactory factory)` private JRElement topElementInGroup; private JRElement bottomElementInGroup; /**
    `protected` | `JRFillElement(JRFillElement element, JRFillCloneFactory factory)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `addDependantElement(JRElement element)`
    `protected void` | `addDynamicProperty(java.lang.String name, JRExpression expression)`
    `java.lang.Object` | `clone()`
    `java.lang.Object` | `clone(JRElementGroup parentGroup)`
    `JRElement` | `clone(JRElementGroup parentGroup, int y)`
    `protected void` | `collectDelayedEvaluations()`
    `protected void` | `collectDelayedEvaluations(JRExpression expression)`
    `protected void` | `collectDelayedEvaluations(JRStyle style)`
    `protected void` | `collectStyleDelayedEvaluations()`
    `protected void` | `collectStyleProviderDelayedEvaluations()`
    `protected abstract JRTemplateElement` | `createElementTemplate()`
    `protected void` | `delayedEvaluate(JRRecordedValuesPrintElement printElement, JREvaluationTime evaluationTime, byte evaluation)`
    `protected boolean` | `delayedEvaluationUpdatesTemplate()`
    `protected abstract void` | `evaluate(byte evaluation)`
    `java.lang.Object` | `evaluateExpression(JRExpression expression, byte evaluation)` Evaluates an expression.
    `protected void` | `evaluatePrintWhenExpression(byte evaluation)`
    `protected void` | `evaluateProperties(byte evaluation)`
    `protected void` | `evaluateStyle(byte evaluation)`
    `protected abstract JRPrintElement` | `fill()`
    `java.awt.Color` | `getBackcolor()`
    `protected JRFillBand` | `getBand()`
    `JRFillElementContainer` | `getConditionalStylesContainer()`
    `JRDefaultStyleProvider` | `getDefaultStyleProvider()`
    `protected java.util.Collection<JRElement>` | `getDependantElements()`
    `JRPropertiesMap` | `getDynamicProperties()`
    `JRElementGroup` | `getElementGroup()` Indicates the logical group that the element belongs to.
    `protected JROrigin` | `getElementOrigin()`
    `protected JRTemplateElement` | `getElementTemplate()`
    `protected JRPropertiesMap` | `getEvaluatedProperties()`
    `protected EvaluationTimeEnum` | `getEvaluationTimeValue()`
    `protected JRFillField` | `getField(java.lang.String fieldName)`
    `JRBaseFiller` | `getFiller()`
    `java.awt.Color` | `getForecolor()`
    `protected JRElement[]` | `getGroupElements()`
    `int` | `getHeight()`
    `protected JRStyle` | `getInitStyle()`
    `java.lang.String` | `getKey()` Returns the string value that uniquely identifies the element.
    `ModeEnum` | `getModeValue()` Returns the element transparency mode.
    `java.awt.Color` | `getOwnBackcolor()`
    `java.awt.Color` | `getOwnForecolor()`
    `ModeEnum` | `getOwnModeValue()`
    `protected JRElement` | `getParent()`
    `JRPropertiesHolder` | `getParentProperties()` Returns the parent properties holder, whose properties are used as defaults for this object.
    `PositionTypeEnum` | `getPositionTypeValue()` Returns the position type for the element
    `JRExpression` | `getPrintWhenExpression()` Gets the expression that is evaluated in order to decide if the element should be displayed.
    `JRGroup` | `getPrintWhenGroupChanges()` Returns the group for which an element with a printRepeatedValues attribute set to true will be redisplayed even if the value has not changed.
    `JRPropertiesMap` | `getPropertiesMap()` Returns this object's properties map.
    `JRPropertyExpression[]` | `getPropertyExpressions()` Returns the list of dynamic/expression-based properties for this report element.
    `protected int` | `getRelativeY()`
    `int` | `getStretchHeight()`
    `StretchTypeEnum` | `getStretchTypeValue()` Indicates the stretch type for the element
    `JRStyle` | `getStyle()` Returns this object's style.
    `java.lang.String` | `getStyleNameReference()` Returns the name of an external style which is to be used by this object.
    `protected JRTemplateElement` | `getTemplate(JRStyle style)`
    `java.util.UUID` | `getUUID()`
    `protected JRFillVariable` | `getVariable(java.lang.String variableName)`
    `int` | `getWidth()`
    `int` | `getX()` Gets the the section relative horizontal offset of the element top left corner.
    `int` | `getY()` Gets the the section relative vertical offset of the element top left corner.
    `boolean` | `hasDynamicProperties()`
    `boolean` | `hasDynamicProperty(java.lang.String name)`
    `boolean` | `hasProperties()` Checks whether the object has any properties.
    `protected void` | `initDelayedEvaluationPrint(JRRecordedValuesPrintElement printElement)`
    `protected void` | `initDelayedEvaluations()`
    `protected void` | `initStyleProviders()`
    `protected boolean` | `isAlreadyPrinted()`
    `protected boolean` | `isAutoEvaluateNow()`
    `protected boolean` | `isDelayedStyleEvaluation()`
    `protected boolean` | `isEvaluateAuto()`
    `protected boolean` | `isEvaluateNow()`
    `boolean` | `isPrintInFirstWholeBand()` Returns true if an element with a printRepeatedValues attribute set to true will be redisplayed for every new page or column that is not an overflow from a previous page or column.
    `boolean` | `isPrintRepeatedValues()` Specifies if the element value will be printed for every iteration, even if its value has not changed.
    `boolean` | `isPrintWhenDetailOverflows()` If this is set to true, the element will be reprinted on the next page if the band does not fit in the current page.
    `protected boolean` | `isPrintWhenExpressionNull()`
    `protected boolean` | `isPrintWhenTrue()`
    `boolean` | `isRemoveLineWhenBlank()` Returns true if the remaining blank space appearing when the value is not printed will be removed.
    `protected boolean` | `isReprinted()`
    `protected boolean` | `isToPrint()`
    `protected boolean` | `isValueRepeating()` Decides whether the value for this element is repeating.
    `protected void` | `moveDependantElements()`
    `protected void` | `performDelayedEvaluation(JRPrintElement element, byte evaluation)`
    `protected boolean` | `prepare(int availableHeight, boolean isOverflow)`
    `protected void` | `registerTemplate(JRStyle style, JRTemplateElement template)`
    `protected void` | `reset()`
    `protected abstract void` | `resolveElement(JRPrintElement element, byte evaluation)` Resolves an element.
    `protected void` | `resolveElement(JRPrintElement element, byte evaluation, JREvaluationTime evaluationTime)` Resolves an element.
    `protected abstract void` | `rewind()`
    `protected void` | `setAlreadyPrinted(boolean isAlreadyPrinted)`
    `void` | `setBackcolor(java.awt.Color backcolor)`
    `protected void` | `setBand(JRFillBand band)`
    `void` | `setConditionalStylesContainer(JRFillElementContainer conditionalStylesContainer)`
    `protected void` | `setCurrentEvaluation(byte evaluation)`
    `protected void` | `setExpressionEvaluator(JRFillExpressionEvaluator expressionEvaluator)`
    `void` | `setForecolor(java.awt.Color forecolor)`
    `void` | `setHeight(int height)`
    `void` | `setMode(ModeEnum modeValue)` Sets the element transparency mode.
    `protected void` | `setOriginProvider(JROriginProvider originProvider)`
    `void` | `setPositionType(PositionTypeEnum positionType)` Sets the position type for the element.
    `void` | `setPrintInFirstWholeBand(boolean isPrint)` Specifies whether an element with a printRepeatedValues attribute set to true should be redisplayed for every new page or column that is not an overflow from a previous page or column.
    `void` | `setPrintRepeatedValues(boolean isPrintRepeatedValues)`
    `void` | `setPrintWhenDetailOverflows(boolean isPrint)` If this is set to true, the element will be reprinted on the next page if the band does not fit in the current page.
    `protected void` | `setPrintWhenExpressionNull(boolean isPrintWhenExpressionNull)`
    `protected void` | `setPrintWhenTrue(boolean isPrintWhenTrue)`
    `protected void` | `setRelativeY(int relativeY)`
    `void` | `setRemoveLineWhenBlank(boolean isRemoveLine)` Specifies whether the remaining blank space appearing when the value is not printed will be removed.
    `protected void` | `setReprinted(boolean isReprinted)`
    `protected void` | `setShrinkable(boolean shrinkable)` Indicates whether an element is shrinkable.
    `protected void` | `setStretchHeight(int stretchHeight)`
    `void` | `setStretchType(StretchTypeEnum stretchType)` Specifies how the engine should treat a missing image.
    `void` | `setStyle(JRStyle style)` Set the style on the object.
    `void` | `setStyleNameReference(java.lang.String name)` Set the name of an external style that is to be used by the object.
    `protected void` | `setToPrint(boolean isToPrint)`
    `protected void` | `setValueRepeating(boolean isValueRepeating)` Sets the repeating flag for this element.
    `void` | `setWidth(int width)`
    `void` | `setX(int x)` Sets the the section relative horizontal offset of the element top left corner.
    `void` | `setY(int y)`
    `protected void` | `stretchElement(int bandStretch)`
    `protected void` | `stretchElementToHeight(int stretchHeight)`
    `protected void` | `stretchHeightFinal()` Called when the stretch height of an element is final so that the element can perform any adjustments.
    `protected void` | `transferProperties(JRPrintElement element)`
    `protected void` | `transferProperties(JRTemplateElement template)`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRElement

      `collectExpressions`

    - ### Methods inherited from interface net.sf.jasperreports.engine.JRVisitable

      `visit`

    - ### Methods inherited from interface net.sf.jasperreports.engine.fill.JRFillCloneable

      `createClone`

- - ### Field Detail

    - #### parent

          protected JRElement parent

    - #### propertyExpressions

          protected java.util.List<JRPropertyExpression> propertyExpressions

    - #### dynamicTransferProperties

          protected java.util.List<java.lang.String> dynamicTransferProperties

    - #### providerStyle

          protected JRStyle providerStyle

    - #### templates

          protected java.util.Map<JRStyle,JRTemplateElement> templates

    - #### styleProviders

          protected java.util.List<StyleProvider> styleProviders

    - #### filler

          protected JRBaseFiller filler

    - #### expressionEvaluator

          protected JRFillExpressionEvaluator expressionEvaluator

    - #### defaultStyleProvider

          protected JRDefaultStyleProvider defaultStyleProvider

    - #### printWhenGroupChanges

          protected JRGroup printWhenGroupChanges

    - #### elementGroup

          protected JRFillElementGroup elementGroup

    - #### band

          protected JRFillBand band

    - #### originProvider

          protected JROriginProvider originProvider

    - #### printElementOriginator

          protected PrintElementOriginator printElementOriginator

    - #### currentEvaluation

          protected byte currentEvaluation

    - #### delayedEvaluationsMap

          protected java.util.Map<JREvaluationTime,net.sf.jasperreports.engine.fill.JRFillElement.DelayedEvaluations> delayedEvaluationsMap

    - #### conditionalStylesContainer

          protected JRFillElementContainer conditionalStylesContainer

    - #### fillContainerContext

          protected FillContainerContext fillContainerContext

    - #### initStyle

          protected JRStyle initStyle

    - #### currentStyle

          protected JRStyle currentStyle

    - #### staticProperties

          protected JRPropertiesMap staticProperties

    - #### dynamicProperties

          protected JRPropertiesMap dynamicProperties

    - #### mergedProperties

          protected JRPropertiesMap mergedProperties

  - ### Constructor Detail

    - #### JRFillElement

          protected JRFillElement(JRBaseFiller filler,
                       JRElement element,
                       JRFillObjectFactory factory)

      private JRElement topElementInGroup; private JRElement bottomElementInGroup; /**

    - #### JRFillElement

          protected JRFillElement(JRFillElement element,
                       JRFillCloneFactory factory)

  - ### Method Detail

    - #### getDefaultStyleProvider

          public JRDefaultStyleProvider getDefaultStyleProvider()

      Specified by:
        `getDefaultStyleProvider` in interface `JRStyleContainer`

    - #### getUUID

          public java.util.UUID getUUID()

      Specified by:
        `getUUID` in interface `JRIdentifiable`

    - #### getKey

          public java.lang.String getKey()

      Description copied from interface: `JRElement`
      Returns the string value that uniquely identifies the element.
      Specified by:
        `getKey` in interface `JRCommonElement`
      Specified by:
        `getKey` in interface `JRElement`

    - #### getPositionTypeValue

          public PositionTypeEnum getPositionTypeValue()

      Description copied from interface: `JRElement`
      Returns the position type for the element
      Specified by:
        `getPositionTypeValue` in interface `JRElement`
      Returns:
        the position type

    - #### setPositionType

          public void setPositionType(PositionTypeEnum positionType)

      Description copied from interface: `JRElement`
      Sets the position type for the element.
      Specified by:
        `setPositionType` in interface `JRElement`
      Parameters:
        `positionType` - the position type

    - #### getStretchTypeValue

          public StretchTypeEnum getStretchTypeValue()

      Description copied from interface: `JRElement`
      Indicates the stretch type for the element
      Specified by:
        `getStretchTypeValue` in interface `JRElement`
      Returns:
        a value representing one of the stretch type constants in `StretchTypeEnum`

    - #### setStretchType

          public void setStretchType(StretchTypeEnum stretchType)

      Description copied from interface: `JRElement`
      Specifies how the engine should treat a missing image.
      Specified by:
        `setStretchType` in interface `JRElement`
      Parameters:
        `stretchType` - a value representing one of the stretch type constants in `StretchTypeEnum`

    - #### isPrintRepeatedValues

          public boolean isPrintRepeatedValues()

      Description copied from interface: `JRElement`
      Specifies if the element value will be printed for every iteration, even if its value has not changed.
      Specified by:
        `isPrintRepeatedValues` in interface `JRElement`
      See Also:
        `JRElement.isRemoveLineWhenBlank()`, `JRElement.isPrintInFirstWholeBand()`

    - #### setPrintRepeatedValues

          public void setPrintRepeatedValues(boolean isPrintRepeatedValues)

      Specified by:
        `setPrintRepeatedValues` in interface `JRElement`

    - #### getModeValue

          public ModeEnum getModeValue()

      Description copied from interface: `JRCommonElement`
      Returns the element transparency mode. The default value depends on the type of the report element. Graphic elements like rectangles and lines are opaque by default, but the images are transparent. Both static texts and text fields are transparent by default, and so are the subreport elements.
      Specified by:
        `getModeValue` in interface `JRCommonElement`

    - #### getOwnModeValue

          public ModeEnum getOwnModeValue()

      Specified by:
        `getOwnModeValue` in interface `JRCommonElement`

    - #### setMode

          public void setMode(ModeEnum modeValue)

      Description copied from interface: `JRCommonElement`
      Sets the element transparency mode.
      Specified by:
        `setMode` in interface `JRCommonElement`

    - #### getX

          public int getX()

      Description copied from interface: `JRElement`
      Gets the the section relative horizontal offset of the element top left corner.
      Specified by:
        `getX` in interface `JRElement`

    - #### setX

          public void setX(int x)

      Description copied from interface: `JRElement`
      Sets the the section relative horizontal offset of the element top left corner.
      Specified by:
        `setX` in interface `JRElement`

    - #### setY

          public void setY(int y)

    - #### getY

          public int getY()

      Description copied from interface: `JRElement`
      Gets the the section relative vertical offset of the element top left corner.
      Specified by:
        `getY` in interface `JRElement`

    - #### getWidth

          public int getWidth()

      Specified by:
        `getWidth` in interface `JRCommonElement`

    - #### setWidth

          public void setWidth(int width)

      Specified by:
        `setWidth` in interface `JRElement`

    - #### setHeight

          public void setHeight(int height)

    - #### getHeight

          public int getHeight()

      Specified by:
        `getHeight` in interface `JRCommonElement`

    - #### isRemoveLineWhenBlank

          public boolean isRemoveLineWhenBlank()

      Description copied from interface: `JRElement`
      Returns true if the remaining blank space appearing when the value is not printed will be removed. Under certain circumstances (the element has an empty string as its value or contains a repeated value that is supressed) the space reserved for the current element remains empty. If this method returns true, it means the engine will try to suppress the blank line, but will only succeed if no other elements occupy the same vertical space.
      Specified by:
        `isRemoveLineWhenBlank` in interface `JRElement`

    - #### setRemoveLineWhenBlank

          public void setRemoveLineWhenBlank(boolean isRemoveLine)

      Description copied from interface: `JRElement`
      Specifies whether the remaining blank space appearing when the value is not printed will be removed. Under certain circumstances (the element has an empty string as its value or contains a repeated value that is supressed) the space reserved for the current element remains empty. If the parameter is set to true, it means the engine will try to suppress the blank line, but will only succeed if no other elements occupy the same vertical space.
      Specified by:
        `setRemoveLineWhenBlank` in interface `JRElement`

    - #### isPrintInFirstWholeBand

          public boolean isPrintInFirstWholeBand()

      Description copied from interface: `JRElement`
      Returns true if an element with a printRepeatedValues attribute set to true will be redisplayed for every new page or column that is not an overflow from a previous page or column.
      Specified by:
        `isPrintInFirstWholeBand` in interface `JRElement`
      See Also:
        `JRElement.isPrintRepeatedValues()`

    - #### setPrintInFirstWholeBand

          public void setPrintInFirstWholeBand(boolean isPrint)

      Description copied from interface: `JRElement`
      Specifies whether an element with a printRepeatedValues attribute set to true should be redisplayed for every new page or column that is not an overflow from a previous page or column.
      Specified by:
        `setPrintInFirstWholeBand` in interface `JRElement`
      See Also:
        `JRElement.isPrintRepeatedValues()`

    - #### isPrintWhenDetailOverflows

          public boolean isPrintWhenDetailOverflows()

      Description copied from interface: `JRElement`
      If this is set to true, the element will be reprinted on the next page if the band does not fit in the current page. Actually if there is at least one element with this attribute, the band is redisplayed from the beginning, except those elements that fitted in the current page and have isPrintWhenDetailOverflow set to false.
      Specified by:
        `isPrintWhenDetailOverflows` in interface `JRElement`

    - #### setPrintWhenDetailOverflows

          public void setPrintWhenDetailOverflows(boolean isPrint)

      Description copied from interface: `JRElement`
      If this is set to true, the element will be reprinted on the next page if the band does not fit in the current page. Actually if there is at least one element with this attribute, the band is redisplayed from the beginning, except those elements that fitted in the current page and have isPrintWhenDetailOverflow set to false.
      Specified by:
        `setPrintWhenDetailOverflows` in interface `JRElement`

    - #### getForecolor

          public java.awt.Color getForecolor()

      Specified by:
        `getForecolor` in interface `JRCommonElement`

    - #### getOwnForecolor

          public java.awt.Color getOwnForecolor()

      Specified by:
        `getOwnForecolor` in interface `JRCommonElement`

    - #### setForecolor

          public void setForecolor(java.awt.Color forecolor)

      Specified by:
        `setForecolor` in interface `JRCommonElement`

    - #### getBackcolor

          public java.awt.Color getBackcolor()

      Specified by:
        `getBackcolor` in interface `JRCommonElement`

    - #### getOwnBackcolor

          public java.awt.Color getOwnBackcolor()

      Specified by:
        `getOwnBackcolor` in interface `JRCommonElement`

    - #### setBackcolor

          public void setBackcolor(java.awt.Color backcolor)

      Specified by:
        `setBackcolor` in interface `JRCommonElement`

    - #### getPrintWhenExpression

          public JRExpression getPrintWhenExpression()

      Description copied from interface: `JRElement`
      Gets the expression that is evaluated in order to decide if the element should be displayed. This expression always returns a boolean value.
      Specified by:
        `getPrintWhenExpression` in interface `JRElement`

    - #### getPrintWhenGroupChanges

          public JRGroup getPrintWhenGroupChanges()

      Description copied from interface: `JRElement`
      Returns the group for which an element with a printRepeatedValues attribute set to true will be redisplayed even if the value has not changed.
      Specified by:
        `getPrintWhenGroupChanges` in interface `JRElement`
      See Also:
        `JRElement.isPrintRepeatedValues()`

    - #### getElementGroup

          public JRElementGroup getElementGroup()

      Description copied from interface: `JRElement`
      Indicates the logical group that the element belongs to. More elements can be grouped in order to get the height of the tallest one.
      Specified by:
        `getElementGroup` in interface `JRElement`
      See Also:
        `StretchTypeEnum.RELATIVE_TO_TALLEST_OBJECT`

    - #### isPrintWhenExpressionNull

          protected boolean isPrintWhenExpressionNull()

    - #### setPrintWhenExpressionNull

          protected void setPrintWhenExpressionNull(boolean isPrintWhenExpressionNull)

    - #### isPrintWhenTrue

          protected boolean isPrintWhenTrue()

    - #### setPrintWhenTrue

          protected void setPrintWhenTrue(boolean isPrintWhenTrue)

    - #### isToPrint

          protected boolean isToPrint()

    - #### setToPrint

          protected void setToPrint(boolean isToPrint)

    - #### isReprinted

          protected boolean isReprinted()

    - #### setReprinted

          protected void setReprinted(boolean isReprinted)

    - #### isAlreadyPrinted

          protected boolean isAlreadyPrinted()

    - #### setAlreadyPrinted

          protected void setAlreadyPrinted(boolean isAlreadyPrinted)

    - #### getGroupElements

          protected JRElement[] getGroupElements()

    - #### getDependantElements

          protected java.util.Collection<JRElement> getDependantElements()

    - #### addDependantElement

          protected void addDependantElement(JRElement element)

    - #### getRelativeY

          protected int getRelativeY()

    - #### setRelativeY

          protected void setRelativeY(int relativeY)

    - #### getStretchHeight

          public int getStretchHeight()

    - #### setStretchHeight

          protected void setStretchHeight(int stretchHeight)

    - #### getBand

          protected JRFillBand getBand()

    - #### setBand

          protected void setBand(JRFillBand band)

    - #### initStyleProviders

          protected void initStyleProviders()

    - #### reset

          protected void reset()

    - #### setCurrentEvaluation

          protected void setCurrentEvaluation(byte evaluation)

    - #### evaluate

          protected abstract void evaluate(byte evaluation)
                                    throws JRException

      Throws:
        `JRException`

    - #### evaluateStyle

          protected void evaluateStyle(byte evaluation)
                                throws JRException

      Throws:
        `JRException`

    - #### evaluatePrintWhenExpression

          protected void evaluatePrintWhenExpression(byte evaluation)
                                              throws JRException

      Throws:
        `JRException`

    - #### rewind

          protected abstract void rewind()
                                  throws JRException

      Throws:
        `JRException`

    - #### fill

          protected abstract JRPrintElement fill()
                                          throws JRException

      Throws:
        `JRException`

    - #### getElementTemplate

          protected JRTemplateElement getElementTemplate()

    - #### createElementTemplate

          protected abstract JRTemplateElement createElementTemplate()

    - #### prepare

          protected boolean prepare(int availableHeight,
                        boolean isOverflow)
                             throws JRException

      Throws:
        `JRException`

    - #### stretchElement

          protected void stretchElement(int bandStretch)

    - #### stretchElementToHeight

          protected void stretchElementToHeight(int stretchHeight)

    - #### moveDependantElements

          protected void moveDependantElements()

    - #### resolveElement

          protected abstract void resolveElement(JRPrintElement element,
                            byte evaluation)
                                          throws JRException

      Resolves an element.
      Parameters:
        `element` - the element
        `evaluation` - the evaluation type
      Throws:
        `JRException`

    - #### performDelayedEvaluation

          protected void performDelayedEvaluation(JRPrintElement element,
                                      byte evaluation)
                                           throws JRException

      Throws:
        `JRException`

    - #### delayedEvaluationUpdatesTemplate

          protected boolean delayedEvaluationUpdatesTemplate()

    - #### evaluateExpression

          public final java.lang.Object evaluateExpression(JRExpression expression,
                                            byte evaluation)
                                                    throws JRException

      Evaluates an expression.
      Parameters:
        `expression` - the expression
        `evaluation` - the evaluation type
      Returns:
        the evaluation result
      Throws:
        `JRException`

    - #### isValueRepeating

          protected boolean isValueRepeating()

      Decides whether the value for this element is repeating.

      Dynamic elements should call `setValueRepeating(boolean)` on `evaluate(byte)`. Static elements don't have to do anything, this method will return `true` by default.

      Returns:
        whether the value for this element is repeating
      See Also:
        `setValueRepeating(boolean)`

    - #### setValueRepeating

          protected void setValueRepeating(boolean isValueRepeating)

      Sets the repeating flag for this element.

      This method should be called by dynamic elements on `evaluate(byte)`.

      Parameters:
        `isValueRepeating` - whether the value of the element is repeating
      See Also:
        `isValueRepeating()`

    - #### getVariable

          protected JRFillVariable getVariable(java.lang.String variableName)

    - #### getField

          protected JRFillField getField(java.lang.String fieldName)

    - #### getEvaluationTimeValue

          protected EvaluationTimeEnum getEvaluationTimeValue()

    - #### resolveElement

          protected void resolveElement(JRPrintElement element,
                            byte evaluation,
                            JREvaluationTime evaluationTime)
                                 throws JRException

      Resolves an element.
      Parameters:
        `element` - the element
        `evaluation` - the evaluation type
        `evaluationTime` - the current evaluation time
      Throws:
        `JRException`

    - #### initDelayedEvaluations

          protected void initDelayedEvaluations()

    - #### collectDelayedEvaluations

          protected void collectDelayedEvaluations()

    - #### collectStyleDelayedEvaluations

          protected void collectStyleDelayedEvaluations()

    - #### collectDelayedEvaluations

          protected void collectDelayedEvaluations(JRStyle style)

    - #### collectDelayedEvaluations

          protected void collectDelayedEvaluations(JRExpression expression)

    - #### collectStyleProviderDelayedEvaluations

          protected void collectStyleProviderDelayedEvaluations()

    - #### initDelayedEvaluationPrint

          protected void initDelayedEvaluationPrint(JRRecordedValuesPrintElement printElement)
                                             throws JRException

      Throws:
        `JRException`

    - #### delayedEvaluate

          protected void delayedEvaluate(JRRecordedValuesPrintElement printElement,
                             JREvaluationTime evaluationTime,
                             byte evaluation)
                                  throws JRException

      Throws:
        `JRException`

    - #### setConditionalStylesContainer

          public void setConditionalStylesContainer(JRFillElementContainer conditionalStylesContainer)

    - #### getConditionalStylesContainer

          public JRFillElementContainer getConditionalStylesContainer()

    - #### getStyle

          public JRStyle getStyle()

      Description copied from interface: `JRStyleContainer`
      Returns this object's style.
      Specified by:
        `getStyle` in interface `JRStyleContainer`
      Returns:
        this object's style

    - #### getTemplate

          protected JRTemplateElement getTemplate(JRStyle style)

    - #### registerTemplate

          protected void registerTemplate(JRStyle style,
                              JRTemplateElement template)

    - #### setShrinkable

          protected final void setShrinkable(boolean shrinkable)

      Indicates whether an element is shrinkable.

      This flag is only effective when `isRemoveLineWhenBlank` is also set.

      Parameters:
        `shrinkable` - whether the element is shrinkable

    - #### stretchHeightFinal

          protected void stretchHeightFinal()

      Called when the stretch height of an element is final so that the element can perform any adjustments.

    - #### isEvaluateNow

          protected boolean isEvaluateNow()

    - #### isAutoEvaluateNow

          protected boolean isAutoEvaluateNow()

    - #### isEvaluateAuto

          protected boolean isEvaluateAuto()

    - #### getStyleNameReference

          public java.lang.String getStyleNameReference()

      Description copied from interface: `JRStyleContainer`
      Returns the name of an external style which is to be used by this object.

      External styles are defined in `templates` and are resolved at fill time. This attribute is only effective if no direct style (as returned by `getStyle()` is specified for this object.
      Specified by:
        `getStyleNameReference` in interface `JRStyleContainer`
      Returns:
        the name of an external style

    - #### setStyle

          public void setStyle(JRStyle style)

      Description copied from interface: `JRStyleSetter`
      Set the style on the object.

      In some cases, this method is invoked after the object has requested its style to be set.
      Specified by:
        `setStyle` in interface `JRStyleSetter`
      Parameters:
        `style` - the style to be used by the object

    - #### setStyleNameReference

          public void setStyleNameReference(java.lang.String name)

      Description copied from interface: `JRStyleSetter`
      Set the name of an external style that is to be used by the object.
      Specified by:
        `setStyleNameReference` in interface `JRStyleSetter`
      Parameters:
        `name` - the name of an external style

    - #### clone

          public java.lang.Object clone()

      Specified by:
        `clone` in interface `JRCloneable`
      Overrides:
        `clone` in class `java.lang.Object`

    - #### clone

          public java.lang.Object clone(JRElementGroup parentGroup)

      Specified by:
        `clone` in interface `JRChild`

    - #### clone

          public JRElement clone(JRElementGroup parentGroup,
                        int y)

      Specified by:
        `clone` in interface `JRElement`

    - #### hasProperties

          public boolean hasProperties()

      Description copied from interface: `JRPropertiesHolder`
      Checks whether the object has any properties.
      Specified by:
        `hasProperties` in interface `JRPropertiesHolder`
      Returns:
        whether the object has any properties

    - #### getPropertiesMap

          public JRPropertiesMap getPropertiesMap()

      Description copied from interface: `JRPropertiesHolder`
      Returns this object's properties map.
      Specified by:
        `getPropertiesMap` in interface `JRPropertiesHolder`
      Returns:
        this object's properties map

    - #### getParentProperties

          public JRPropertiesHolder getParentProperties()

      Description copied from interface: `JRPropertiesHolder`
      Returns the parent properties holder, whose properties are used as defaults for this object.
      Specified by:
        `getParentProperties` in interface `JRPropertiesHolder`
      Returns:
        the parent properties holder, or `null` if no parent

    - #### getPropertyExpressions

          public JRPropertyExpression[] getPropertyExpressions()

      Description copied from interface: `JRElement`
      Returns the list of dynamic/expression-based properties for this report element.
      Specified by:
        `getPropertyExpressions` in interface `JRElement`
      Returns:
        an array containing the expression-based properties of this report element

    - #### transferProperties

          protected void transferProperties(JRTemplateElement template)

    - #### transferProperties

          protected void transferProperties(JRPrintElement element)

    - #### getEvaluatedProperties

          protected JRPropertiesMap getEvaluatedProperties()

    - #### evaluateProperties

          protected void evaluateProperties(byte evaluation)
                                     throws JRException

      Throws:
        `JRException`

    - #### setOriginProvider

          protected void setOriginProvider(JROriginProvider originProvider)

    - #### getElementOrigin

          protected JROrigin getElementOrigin()

    - #### isDelayedStyleEvaluation

          protected boolean isDelayedStyleEvaluation()

    - #### getFiller

          public JRBaseFiller getFiller()

    - #### hasDynamicProperties

          public boolean hasDynamicProperties()

      Specified by:
        `hasDynamicProperties` in interface `DynamicPropertiesHolder`

    - #### hasDynamicProperty

          public boolean hasDynamicProperty(java.lang.String name)

      Specified by:
        `hasDynamicProperty` in interface `DynamicPropertiesHolder`

    - #### getDynamicProperties

          public JRPropertiesMap getDynamicProperties()

      Specified by:
        `getDynamicProperties` in interface `DynamicPropertiesHolder`

    - #### getInitStyle

          protected JRStyle getInitStyle()

    - #### getParent

          protected JRElement getParent()

    - #### addDynamicProperty

          protected void addDynamicProperty(java.lang.String name,
                                JRExpression expression)

    - #### setExpressionEvaluator

          protected void setExpressionEvaluator(JRFillExpressionEvaluator expressionEvaluator)

© 2001-2010 Jaspersoft Corporation www.jaspersoft.com